<?php
/*
$Id$

Zencart PaymentSense Re-Direct Payment Module
Copyright (C) 2011 PaymentSense.
Support: ecomsupport@paymentsense.com

------------------------

Last Updated: 13/12/2011

------------------------

Released under the GNU General Public License
*/

  class paymentsense_redirect {
    var $code, $title, $description, $enabled, $db;

// class constructor
    function paymentsense_redirect() {
		global $order, $db;
		$this->code = 'paymentsense_redirect';
		$this->title = 'PaymentSense Redirect';
		$this->version = '2.1';
		$this->versiondate = '13 December 2011';
		$this->sort_order = MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_STATUS == 'True') ? true : false);
		$this->public_title = MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_PUBLIC_TITLE;
		
		$this->order_status = DEFAULT_ORDERS_STATUS_ID;
		$this->form_action_url = HTTP_SERVER . DIR_WS_CATALOG . DIR_WS_MODULES . "payment/paymentsense_redirect/processpayment.php";

		$critical_config_problem = false;
		
		$paymentsense_redirect_config_messages = '';

		// Output warning if database table doesn't exist
		$table_exists_query = 'SHOW TABLES LIKE "' . TABLE_PAYMENTSENSE_REDIRECT . '";';
		$table_exists_result = $db->Execute($table_exists_query);

		if ($table_exists_result->EOF && $this->enabled == true) {
			// Database doesn't exist
			$critical_config_problem = true;
			$paymentsense_redirect_config_messages .= '<p><span style="color: red"><b>Warning:</b><br />The PaymentSense Redirect Database Table Does Not Exist!<br /><b>Please re-install this module, or create the database table as described in the installation instructions before proceeding.</b></span></p>';
		}
		
		$this->description = "	<p><b>PaymentSense Redirect Payment Module</b><br>
								<b>Version:</b> ". $this->version ."<br>
								<b>Release Date:</b> ". $this->versiondate ."</p>
								
								<p><a href=\"https://mms.paymentsense.com\">PaymentSense Merchant Management System (MMS)</a><br>
								<a href=\"mailto:ecomsupport@paymentsense.com\">PaymentSense Integration Support</a><br>
								<a href=\"http://www.paymentsense.co.uk\">PaymentSense website</a></p>
								
								<p>For integration support email the PaymentSense Team</p>" . $paymentsense_redirect_config_messages;
    }

	// class methods
    function update_status() {
      global $order, $db;
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->public_title);
    }

    function pre_confirmation_check() {
      return false;
    }

	function confirmation() {
		global $cartID, $customer_id, $languages_id, $order, $order_total_modules, $db;
		return false;
    }

    function process_button() {
      global $order, $order_total_modules, $currencies, $currency, $cartID;

		$process_button_string = zen_draw_hidden_field('MerchantID', MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_ID);
								
      return $process_button_string;
    }

    function before_process() {
		return false;
    }

    function after_process() {
		return false;
    }

    function get_error() {

		if ($_GET['error'] == 'n') {
			$error_message = MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_ERROR_MESSAGE_N;
		} elseif ($_GET['error'] == 'c') {
			$error_message = MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_ERROR_MESSAGE_C;
		} else {
			$error_message = MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_ERROR_MESSAGE;
		}
  
		$custom_message = stripslashes(urldecode($_GET['customerror']));
		$custom_message = str_replace('|lt;|', '<', $custom_message);
		$custom_message = str_replace('|gt;|', '>', $custom_message);
		
		if  ($custom_message != "") {
			$error_message .= " (". $custom_message ."). Please try another card.";
		} else {
			$error_message .= ".";
		}
		
		$error = array(
			'title' => MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_ERROR,
			'error' => $error_message
			);
		return $error;
    }

    function check() {
	global $db;
      if (!isset($this->_check)) {
		$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
		global $db, $messageStack;
		if (defined('MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_STATUS')) {
			$messageStack->add_session('PaymentSense Redirect module already installed.', 'error');
			zen_redirect(zen_href_link(FILENAME_MODULES, 'set=payment&module=paymentsense_redirect', 'NONSSL'));
			return 'failed';
		}
		
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Text Title', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_PUBLIC_TITLE', 'Credit/Debit Card', 'Title to use on payment form', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PaymentSense Redirect Module', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_STATUS', 'False', 'Do you want to accept payments through the PaymentSense gateway?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_ID', 'MerchantID', 'Merchant ID to use', '6', '2', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant Password', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_PASSWORD', 'MerchantPassword', 'The gateway account password.', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Pre-Shared Key', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_PRESHARED_KEY', 'yourPSK', 'The Pre-Shared Key from the PaymentSense MMS for this gateway account.', '6', '0', now())");      
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_CURRENCY', 'GBP', 'The currency to use for credit card transactions', '6', '3', 'zen_cfg_select_option(array(\'GBP\', \'EUR\', \'USD\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Display Order.', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Successful Order Status', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_ORDER_STATUS_ID', '0', 'Update the Order Status to this value when a payment is successful.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Failed Order Status', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_ORDER_STATUS_ID_FAILED', '0', 'Update the Order Status to this value when a payment fails.', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
		
		$query = "SELECT * FROM ". TABLE_ORDERS_STATUS ." ORDER BY orders_status_id desc LIMIT 1";
		$row = $db->Execute($query);

		$LastInsertID = intval($row->fields["orders_status_id"]);
		$LastInsertID1 = $LastInsertID + 1;
		$LastInsertID2 = $LastInsertID + 2;
		
		$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values (". $LastInsertID1 .", 1, 'Payment Failed')");
		$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values (". $LastInsertID2 .", 1, 'Payment Successful')");	
		
		$db->Execute("CREATE TABLE `". TABLE_PAYMENTSENSE_REDIRECT ."` (
					`id` int(11) unsigned NOT NULL auto_increment,
					`cross_reference` varchar(25) NOT NULL,
					`zen_order_id` int(11) NOT NULL,
					`auth_code` varchar(15) NOT NULL,
					`message` varchar(255) default NULL,
					`amount_received` varchar(15) default NULL,
					`transaction_result` int(11) default NULL,
					PRIMARY KEY (`id`))");
    }

    function remove() {
		global $db;
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		$db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Payment Failed'");
		$db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Payment Successful'");
		$db->Execute("drop table ". TABLE_PAYMENTSENSE_REDIRECT);
    }

    function keys() {
      return array('MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_STATUS', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_ID', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_MERCHANT_PASSWORD', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_PRESHARED_KEY', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_CURRENCY', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_ORDER_STATUS_ID_FAILED', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_SORT_ORDER', 'MODULE_PAYMENT_PAYMENTSENSE_REDIRECT_TEXT_PUBLIC_TITLE');
    }
  }
?>
